<?php
if (!isset($SITE)){
	header ("Location: ../index.php");	// back to index/startpage if someone tries an
	exit;  								//  page to load without menu system//
}
$pageName		= 'wsDataGet.php';
$pageVersion	= '2.30 2013-09-30';
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {
	$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;
}
echo '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->".PHP_EOL;
#---------------------------------------------------------------------------
# 2.31 2013-09-26 update version - save tags in array
#---------------------------------------------------------------------------
$uomTemp	= $SITE['uomTemp'];
$uomBaro	= $SITE['uomBaro'];
$uomRain	= $SITE['uomRain'];
$uomSnow	= $SITE['uomSnow'];
$uomDistance= $SITE['uomDistance'];
$uomWind	= $SITE['uomWind'];
$uomPerHour	= $SITE['uomPerHour'];
$uomHeight	= $SITE['uomHeight'];
#---------------------------------------get current weather values and yesterday values --
$fileToLoad = $SITE['wsTags'];
$useUpload	= true;
$uoms		= $uomTemp.$uomBaro.$uomWind.$uomRain.$uomSnow.$uomDistance.$uomPerHour.$uomHeight;
$from		= array('/',' ','&deg;','.php');
$to			= '_';
$cachedFile	= $SITE['cacheDir'].str_replace ($from, $to, $fileToLoad.$uoms);  // add uoms
if (file_exists($cachedFile)){
	$fileTimeCache	= filectime($cachedFile); 
	$fileTimeUpload	= filectime($fileToLoad); 
	if ($fileTimeCache > $fileTimeUpload) {
		$useUpload	= false;
		echo '<!-- uploaded file older than cached file  -->'.PHP_EOL;
	} 
}
if ($useUpload) {
	echo '<!-- loading '.$SITE['wsTags'].' -->'.PHP_EOL;
	include($SITE['wsTags']);				// current weatherdata
	if (isset ($SITE['wsYTags'])  && $SITE['wsYTags']  <> '') {
		echo '<!-- loading '.$SITE['wsYTags'].' -->'.PHP_EOL;
		include($SITE['wsYTags']);    		// yesterday values 
	}
	if (!isset ($ws['actTime']) ) {
		$useUpload = false;				// check if correct file was read
		echo '<!-- uploaded file incorrect - reverting to cached file -->'.PHP_EOL;
	} else {
		if (!isset ($wsTrends) ) { 
			echo '<!-- no trends to cache -->'.PHP_EOL;
		} else {
			$ws['trendsExist'] = $cacheTrends	= $cachedFile.'_trends';
			if (!file_put_contents($cacheTrends, serialize($wsTrends)) ){   
				echo PHP_EOL.'<!-- Could not save data (trends) to cache ('.$cacheTrends.'). Please make sure your cache directory exists and is writable. -->'.PHP_EOL;
			} else {
				echo '<!-- Weatherdata trends saved to cache ('.$cacheTrends.')  -->'.PHP_EOL;
			}
		}
		if (!file_put_contents($cachedFile, serialize($ws)) ){   
			echo PHP_EOL.'<!-- Could not save tags from '.$ws['actTime'].' to cache ('.$cachedFile.'). Please make sure your cache directory exists and is writable. -->'.PHP_EOL;
		} else {
			echo '<!-- Weatherdata tags from '.$ws['actTime'].' - saved to cache ('.$cachedFile.')  -->'.PHP_EOL;
		}
	}
}
if (!$useUpload) {
	$ws = unserialize(file_get_contents($cachedFile));
	echo '<!-- loading tag files from '.$cachedFile.' -->'.PHP_EOL;
	if (!isset ($ws['actTime']) ) { exit ('<h3>no valid tags file found - program halts </h3>'); }
}
$nowInt		= time();
$now		= date($SITE["timeOnlyFormat"],$nowInt);
$lat		= $SITE['latitude'];
$long		= $SITE['longitude'];
$sunriseInt	= date_sunrise($nowInt, SUNFUNCS_RET_TIMESTAMP, $lat, $long);   // standard time integer
$sunsetInt	= date_sunset ($nowInt, SUNFUNCS_RET_TIMESTAMP, $lat, $long);
$sunrise	= $ws['sunrise']	= date($SITE["timeOnlyFormat"],$sunriseInt);
$sunset		= $ws['sunset']		= date($SITE["timeOnlyFormat"],$sunsetInt);
if (isset ($ws['moonrise'])  && $ws['moonrise'] <> 0){
	$string = ' Thu, 21 Dec 2000 '.$ws['moonrise'];
	$ws['moonrise'] = date($SITE["timeOnlyFormat"],strtotime($string));
}
if (isset ($ws['moonset'])  && $ws['moonset'] <> 0){
	$string = ' Thu, 21 Dec 2000 '.$ws['moonset'];
	$ws['moonset'] = date($SITE["timeOnlyFormat"],strtotime($string));
}
if (($nowInt >= $sunriseInt) && ($nowInt <= $sunsetInt)) {
	$dayNight = 'daylight';
} else {
	$dayNight = 'nighttime';				
}
if ($wsDebug) { echo "<!-- wsDataGet.php time  is $nowInt => $now  | it is  $dayNight | sunrise at $sunriseInt => $sunrise  | sunset at  $sunsetInt => $sunset -->".PHP_EOL;}

include_once ('wsIconUrl.php');
#---------------------- and now get the current conditions from some source --------------
if ($wsDebug) { echo '<!-- wsDataGet.php $SITE["curCondFrom"] = '.$SITE['curCondFrom'].'  -->'.PHP_EOL;}
#
if (!isset ($SITE['curCondFrom'])) {$SITE['curCondFrom'] = 'metar';}	// default metar curcond
#
switch ($SITE['curCondFrom']) {	
	case 'yahoo':
	include_once('forecasts/yahoo.weather2.php');
	$weather 	= new yahooWeather();
	$yahooArray	= $weather->getWeatherData($SITE['yaPlaceID']);
	$condDesc   = cleanCurCond($yahooArray['ccn']['1']['text']);
	$ccnIconNr	= $iconIn 	= $yahooArray['ccn']['1']['icon'];
	$ccnIconUrl	= $urlIn	= $yahooArray['ccn']['1']['iconUrl'];
	wsChangeIcon ('yahoo',$iconIn, $ccnIconNr, $urlIn, $ccnIconUrl);		
	$headerClass= wsHeaderLookup ('yahoo',$iconIn);
	break;
	case 'wd':
	$condDesc   = cleanCurCond($ws['wdCurCond']);
	$ccnIconNr	= $ccnIconUrl = $urlIn	= $notUsed	= '';
	wsChangeIcon ('wd',$ws['wdCurIcon'], $ccnIconNr, $urlIn, $ccnIconUrl);
	$headerClass= wsHeaderLookup ('wd',$ws['wdCurIcon']);	
	break;
	case 'metar':
	include_once ('wsMetarXml.php');
	$end		= count ($arrConditions);
	$condDesc   = '';
	for ($i = 0; $i < $end; $i++) {
		$condDesc .= langtransstr($arrConditions[$i]['txt']).'<br />';
	}
	if ($coverDescription == 'Clear' && $dayNight <> 'nighttime') {$coverDescription = 'sunny';}
	$condDesc  .= langtransstr($coverDescription);
	if ($dayNight == 'nighttime') {$iconNrPr .='n';}
	$icon		= $iconNrPr;
	wsChangeIcon ('default',$icon, $icon, '', $ccnIconUrl);
	$ccnIconNr = $iconNrPr;
	$headerClass= wsHeaderLookup ('default',$iconNrPr);	
	break;
}
return;
#-----------------------------------------------------------------------------------------
function cleanCurCond($words) {
	$arrTxt=explode ('/',$words);		// AM Light Snow/ Drizzle late
	$cndTxt='';
	$iEnd=count($arrTxt)-1;
	for ($i2=0;$i2<=$iEnd;$i2++)
	{
		$text=$arrTxt[$i2];
		if ($text <> '') {
			if (substr($text,0,2) == 'AM') {
				$cndTxt.=langtransstr('Morning'). ': ';
				$text=substr($text,2);
			}
			if (substr($text,0,2) == 'PM') {
				$cndTxt.=langtransstr('Afternoon'). ': ';
				$text=substr($text,2);
			}
			if (substr($text,-5) == ' Late') {
				$cndTxt.=langtransstr('Late'). ': ';
				$text=substr($text,0,strlen($text)-5);
			}				
			if (substr($text,0,2) == 'PM') {
				$cndTxt.=langtransstr('Afternoon'). ': ';
				$text=substr($text,2);
			}			
			$cndTxt.=htmlentities(langtransstr($text));
			if ($iEnd > $i2) {$cndTxt.='<br />';}
		}
	}
	return( $cndTxt);
}
?>